Data::ObjectDriver::Profiler(3pm)

NAME
Data::ObjectDriver::Profiler - Query profiling

SYNOPSIS
    my $profiler = Data::ObjectDriver->profiler;

    my $stats = $profiler->statistics;
    my $total = $stats->{'DBI:total_queries'};

    my $log = $profiler->query_log;

    $profiler->reset;

USAGE

  $Data::ObjectDriver::PROFILE
To turn on profiling, set $Data::ObjectDriver::PROFILE to a true value. Alternatively, you can set the DOD_PROFILE environment variable to a true value before starting your application.

  Data::ObjectDriver->profiler
Profiling is global to Data::ObjectDriver, so the Profiler object is a global instance variable. To get it, call Data::ObjectDriver->profiler, which returns a Data::ObjectDriver::Profiler object.

  $profiler->statistics
Returns a hash reference of statistics about the queries that have been executed.

  $profiler->query_log
Returns a reference to an array of SQL queries as they were handed off to DBI. This means that placeholder variables are not substituted, so you'll end up with queries in the query log like "SELECT title, difficulty FROM recipe WHERE recipe_id = ?".

  $profiler->query_frequency
Returns a reference to a hash containing, as keys, all of the SQL statements in the query log, where the value for each of the keys is a number representing the number of times the query was executed.

  $profiler->reset
Resets the statistics and the query log.

  $profiler->total_queries
Returns the total number of queries currently logged in the profiler.

  $profiler->report_queries_by_type
Returns a string containing a pretty report of information about the current number of each type of query in the profiler (e.g. "SELECT", "INSERT").

  $profiler->report_query_frequency
Returns a string containing a pretty report of information about the current query frequency information in the profiler.